// src/backend/dynamic_process.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef DYNAMIC_PROCESS_HH
#define DYNAMIC_PROCESS_HH 1

#include "config.h"
#include "gettext.h"
#include "glibmm/ustring.h"
#include <vector>

#include "process.hh"
#include "../templates/smartp.hh"
#include "dynamic_schedulable.hh"

namespace sgpem
{
  class DynamicProcess;
  class StaticProcess;
  class DynamicThread;
  class Thread;

  class SG_DLLEXPORT DynamicProcess : public DynamicSchedulable, public Process
  {
  public:
    DynamicProcess(StaticProcess* core);
    DynamicProcess(const DynamicProcess &other);
    
    std::vector<Thread*> get_threads();
    
    state get_state() const;

    void remove_thread(Thread* thread);
    void add_thread(DynamicThread* thread);

    void serialize(SerializeVisitor& translator) const;
    
  private:
    std::vector<DynamicThread*> _dynamic_threads;
  };
    
}

#endif

